-- | "Prolongation" creates describes the correct form for prolongation trees

{-

tree-traversing ideas.

idea 1:

Have size :: ProlongationTree -> Int

have an array of chords 

test suitability

repeat 10000x say

points: SLOW

idea 2:

enrich ProlongatonTree with chord vertex data
somehow assign chords from the top down...top chord arbitrarily assigned, others chosen to agree
but how? not clear...(would need to be able to navigate up *and* down)

need a function from ProlongationTree to TwoWayEnrichedProlongationTree  (only need to enrich the NullTrees ;P  )

then rules might be easer?

say a point on a right branch...to find branch to its right...need to travel to highest right branching area, then down (keeping to the left) to nullbranch
<- is probably the way to go

need to generate arch, and check for LOCAL inequalities of tension and ARCH-WIDE inequalities of relatedness .. should do as an approximation...

-}

module Prolongation where
import Random
import System.Random
import Data.Generics
import Data.List hiding (transpose)
import Chords

-- | will want to weight this eventually...
data ProlongationVertex = Prolong_Strong | Prolong_Weak | Prog 
                          deriving Show
instance Random ProlongationVertex where
  randomR (a,b) g = 
      case (randomR (toInteger (pv2Int a), toInteger (pv2Int b)) g) of
        (x, g) -> (int2pv x, g)
       where
         pv2Int Prolong_Strong = 0
         pv2Int Prolong_Weak  = 1
         pv2Int Prog  = 5

	 int2pv 0	= Prolong_Strong
	 int2pv 1	= Prolong_Weak
	 int2pv _	= Prog
  random g	  = randomR (Prolong_Strong,Prog) g


data Branch = B_Left | B_Right 
      deriving (Show, Eq)


instance Random Branch where
  randomR (a,b) g = 
      case (randomR (toInteger (bool2Int a), toInteger (bool2Int b)) g) of
        (x, g) -> (int2Bool x, g)
       where
         bool2Int B_Left = 0
         bool2Int B_Right  = 1

	 int2Bool 0	= B_Left
	 int2Bool _	= B_Right
  random g	  = randomR (B_Left,B_Right) g


data ProlongationTree = P_Tree {
     vertex :: ProlongationVertex,
     branch :: Branch,
     child_l :: ProlongationTree,
     child_r :: ProlongationTree
    } 
    | NullTree
      deriving Show


balanceConstraint :: ProlongationTree -> Bool
balanceConstraint NullTree = True
balanceConstraint t@P_Tree {
                        vertex = Prog
                      } = balanceConstraint (child_l t) && balanceConstraint (child_r t)
balanceConstraint t@P_Tree {
                        child_l = P_Tree {
                                    branch=B_Right
                                  },
                        child_r = P_Tree {
                                    branch=B_Left
                                  }                                    
                      } = balanceConstraint (child_l t) && balanceConstraint (child_r t)
balanceConstraint t@P_Tree {
                        child_l = P_Tree {
                                    branch=B_Left
                                  },
                        child_r = P_Tree {
                                    branch=B_Left,
                                    child_l = P_Tree {
                                                branch=B_Left
                                              }
                                  }  
                      } = False
balanceConstraint t@P_Tree {
                        child_l = P_Tree {
                                    branch=B_Right,
                                    child_l = P_Tree {
                                                branch=B_Right
                                              }
                                  },
                        child_r = P_Tree {
                                    branch=B_Right
                                  } 
                      } = False
balanceConstraint t = balanceConstraint (child_l t) && balanceConstraint (child_r t)


recursionConstraint :: ProlongationTree -> Bool
recursionConstraint NullTree = True
recursionConstraint t@P_Tree{
                          vertex = Prog,
                          branch = B_Right,
                          child_l = P_Tree {
                                      vertex=Prog,
                                      branch=B_Right
                                    }
                        } = False
recursionConstraint t@P_Tree{
                          vertex = Prog,
                          branch = B_Left,
                          child_r = P_Tree {
                                      vertex=Prog,
                                      branch=B_Left
                                    }
                        } = False
recursionConstraint t = recursionConstraint (child_l t)  && recursionConstraint (child_r t)


basicForm :: ProlongationTree
basicForm = P_Tree { 
              vertex = Prolong_Weak,
              branch = B_Left,
              child_l = NullTree,
              child_r = P_Tree {
                          vertex=Prog,
                          branch= B_Left,
                          child_l=NullTree,
                          child_r=NullTree
                        }
            }


exampleTree1 :: ProlongationTree
exampleTree1 = P_Tree {
                   vertex = Prolong_Weak,
                   branch = B_Left,
                   child_l = P_Tree {
                               vertex = Prolong_Strong,
                               branch = B_Right,
                               child_l=NullTree,
                               child_r= P_Tree {
                                          vertex = Prog,
                                          branch = B_Right,
                                          child_l = NullTree,
                                          child_r = NullTree
                                        }
                          },
                   child_r = P_Tree {
                               vertex = Prog,
                               branch = B_Left,
                               child_l = P_Tree {
                                           vertex = Prolong_Weak,
                                           branch = B_Right,
                                           child_l = NullTree,
                                           child_r = NullTree
                                         },
                               child_r = P_Tree {
                                           vertex = Prolong_Weak,
                                           branch = B_Left,
                                           child_l = NullTree,
                                           child_r = NullTree
                                         }
                             }
                 }



normativeForm1 :: ProlongationTree
normativeForm1 = P_Tree {
                   vertex = Prolong_Weak,
                   branch = B_Left,
                   child_l = P_Tree {
                               vertex = Prolong_Strong,
                               branch = B_Right,
                               child_l=NullTree,
                               child_r= NullTree 
                             },
                   child_r = P_Tree {
                               vertex = Prog,
                               branch = B_Left,
                               child_l = P_Tree {
                                           vertex = Prolong_Weak,
                                           branch = B_Left,
                                           child_l = NullTree,
                                           child_r = NullTree
                                         },
                               child_r = NullTree
                             }
                 }


normativeForm2 :: ProlongationTree
normativeForm2 = P_Tree {
                   vertex = Prolong_Weak,
                   branch = B_Left,
                   child_l = P_Tree {
                               vertex = Prolong_Strong,
                               branch = B_Right,
                               child_l = P_Tree {
                                           vertex = Prolong_Strong,
                                           branch = B_Right,
                                           child_l = NullTree,
                                           child_r = NullTree 
                                         },
                               child_r= NullTree 
                             },
                   child_r = P_Tree {
                               vertex = Prog,
                               branch = B_Left,
                               child_l = P_Tree {
                                           vertex = Prolong_Weak,
                                           branch = B_Left,
                                            child_l = NullTree,
                                           child_r = NullTree
                                         },
                               child_r = NullTree
                             }
                 }



normativeForm1map :: ProlongationTree -> ProlongationTree -> ProlongationTree -> ProlongationTree -> ProlongationTree -> ProlongationTree
normativeForm1map a b c d e = P_Tree {
                   vertex = Prolong_Weak,
                   branch = B_Left,
                   child_l = P_Tree {
                               vertex = Prolong_Strong,
                               branch = B_Right,
                               child_l=a,
                               child_r= b 
                             },
                   child_r = P_Tree {
                               vertex = Prog,
                               branch = B_Left,
                               child_l = P_Tree {
                                           vertex = Prolong_Weak,
                                           branch = B_Left,
                                           child_l = c,
                                           child_r = d
                                         },
                               child_r = e
                             }
                 }

normativeForm2map ::ProlongationTree -> ProlongationTree -> ProlongationTree -> ProlongationTree -> ProlongationTree -> ProlongationTree -> ProlongationTree
normativeForm2map a b c d e f = P_Tree {
                   vertex = Prolong_Weak,
                   branch = B_Left,
                   child_l = P_Tree {
                               vertex = Prolong_Strong,
                               branch = B_Right,
                               child_l = P_Tree {
                                           vertex = Prolong_Strong,
                                           branch = B_Right,
                                           child_l = a,
                                           child_r = b 
                                         },
                               child_r= c 
                             },
                   child_r = P_Tree {
                               vertex = Prog,
                               branch = B_Left,
                               child_l = P_Tree {
                                           vertex = Prolong_Weak,
                                           branch = B_Left,
                                            child_l = d,
                                           child_r = e
                                         },
                               child_r = f
                             }
                 }


unbalancedPTree :: ProlongationTree
unbalancedPTree = P_Tree {
                   vertex = Prolong_Weak,
                   branch = B_Left,
                   child_l = P_Tree {
                               vertex = Prolong_Strong,
                               branch = B_Right,
                               child_l = P_Tree {
                                           vertex = Prolong_Strong,
                                           branch = B_Right,
                                           child_l = NullTree,
                                           child_r = NullTree 
                                         },
                               child_r= NullTree 
                             },
                   child_r = P_Tree {
                               vertex = Prog,
                               branch = B_Right,
                               child_l = NullTree,
                               child_r = NullTree
                             }
                 }

constraintsSatisfied :: ProlongationTree -> Bool
constraintsSatisfied t = balanceConstraint t && recursionConstraint t


-- |the pattern-matching is to check if it is in either of the two normative forms
acceptableTree :: ProlongationTree -> Bool 
acceptableTree P_Tree{ 
                     vertex=Prog
                   } = False
acceptableTree t@ P_Tree {
                   vertex = Prolong_Weak,
                   branch = B_Left,
                   child_l = P_Tree {
                               vertex = Prolong_Strong,
                               branch = B_Right
                             },
                   child_r = P_Tree {
                               vertex = Prog,
                               branch = B_Left,
                               child_l = P_Tree {
                                           vertex = Prolong_Weak,
                                           branch = B_Left
                                         }
                             }
                 } = constraintsSatisfied t
acceptableTree t@P_Tree {
                     branch = B_Left,
                     child_l = P_Tree {
                                 vertex = Prolong_Strong,
                                 branch = B_Right,
                                 child_l = P_Tree {
                                           vertex = Prolong_Strong,
                                           branch = B_Right
                                           }
                             },
                   child_r = P_Tree {
                               vertex = Prog,
                               branch = B_Left,
                               child_l = P_Tree {
                                           vertex = Prolong_Weak,
                                           branch = B_Left
                                         }
                             }                     
                   }
    = constraintsSatisfied t
acceptableTree _ = False

-- |don't yet know why this might be useful
pt_branches :: ProlongationTree -> [ProlongationTree]
pt_branches t@P_Tree{ child_l=l, child_r=r} = t: (pt_branches l) ++ (pt_branches r)
pt_branches NullTree = []

pt_rand :: RandomGen g => g -> Int -> ProlongationTree
pt_rand _ 0 = NullTree
pt_rand g depth = if (constraintsSatisfied treeCand) then 
                      treeCand
                  else
                      pt_rand g2 (depth-1)
                      where 
                        (r1,g1) = random g
                        (r2,g2) = random g1
                        (ga,gb) = split g2
                        treeCand = P_Tree {
                                     vertex=r1,
                                     branch=r2,
                                     child_l = pt_rand ga (depth-1),
                                     child_r = pt_rand gb (depth-1)
                                   }

pt_norm1rand :: RandomGen g => g -> Int -> ProlongationTree
pt_norm1rand g depth = if (constraintsSatisfied treeCand) then 
                      treeCand
                  else
                      pt_norm1rand gf (depth-1)
    where
           (ga,gk1) = split g
           (gb,gk2) = split gk1
           (gc,gk3) = split gk2
           (gd,gk4) = split gk3
           (ge,gk5) = split gk4
           (gf,gk6) = split gk5
           treeCand =  normativeForm1map 
                       (pt_rand ga (depth-1)) 
                       (pt_rand gb (depth-1))
                       (pt_rand gc (depth-1)) 
                       (pt_rand gd (depth-1)) 
                       (pt_rand ge (depth-1))
                         
pt_norm2rand :: RandomGen g => g -> Int -> ProlongationTree
pt_norm2rand g depth = if (constraintsSatisfied treeCand) then 
                      treeCand
                  else
                      pt_norm1rand gg (depth-1)
    where
           (ga,gk1) = split g
           (gb,gk2) = split gk1
           (gc,gk3) = split gk2
           (gd,gk4) = split gk3
           (ge,gk5) = split gk4
           (gf,gk6) = split gk5
           (gg,gk7) = split gk6
           treeCand =  normativeForm2map 
                       (pt_rand ga (depth-1)) 
                       (pt_rand gb (depth-1))
                       (pt_rand gc (depth-1)) 
                       (pt_rand gd (depth-1)) 
                       (pt_rand ge (depth-1))
                       (pt_rand gf (depth-1))